Torque2D Reference

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | List of all members
GenericDocument< Encoding, Allocator > Class Template Reference

A document for parsing JSON text as DOM. More...

`#include <document.h>`

Inheritance diagram for GenericDocument< Encoding, Allocator >:

## Public Types
typedef Encoding::Ch | Ch
| Character type derived from Encoding. More...
typedef GenericValue< Encoding, Allocator > | ValueType
| Value type of the document. More...
typedef Allocator | AllocatorType
| Allocator type from template parameter. More...
Public Types inherited from GenericValue< Encoding, Allocator >
typedef Encoding | EncodingType
| Encoding type from template parameter. More...
typedef Allocator | AllocatorType
| Allocator type from template parameter. More...
typedef Encoding::Ch | Ch
| Character type derived from Encoding. More...
typedef Member * | MemberIterator
| Member iterator for iterating in object. More...
typedef const Member * | ConstMemberIterator
| Constant member iterator for iterating in object. More...
typedef GenericValue * | ValueIterator
| Value iterator for iterating in array. More...
typedef const GenericValue * | ConstValueIterator
| Constant value iterator for iterating in array. More...

## Public Member Functions
| GenericDocument (Allocator *allocator=0, size_t stackCapacity=kDefaultStackCapacity)
| Constructor. More...
template<unsigned parseFlags, typename SourceEncoding , typename InputStream >
GenericDocument & | ParseStream (InputStream &is)
| Parse JSON text from an input stream. More...
template<unsigned parseFlags, typename SourceEncoding >
GenericDocument & | ParseInsitu (Ch *str)
| Parse JSON text from a mutable string. More...
template<unsigned parseFlags>
GenericDocument & | ParseInsitu (Ch *str)
template<unsigned parseFlags, typename SourceEncoding >
GenericDocument & | Parse (const Ch *str)
| Parse JSON text from a read-only string. More...
template<unsigned parseFlags>
GenericDocument & | Parse (const Ch *str)
bool | HasParseError () const
| Whether a parse error was occured in the last parsing. More...
const char * | GetParseError () const
| Get the message of parsing error. More...
size_t | GetErrorOffset () const
| Get the offset in character of the parsing error. More...
Allocator & | GetAllocator ()
| Get the allocator of this document. More...
size_t | GetStackCapacity () const
| Get the capacity of stack in bytes. More...
void | Null ()
void | Bool (bool b)
void | Int (int i)
void | Uint (unsigned i)
void | Int64 (int64_t i)
void | Uint64 (uint64_t i)
void | Double (double d)
void | String (const Ch *str, SizeType length, bool copy)
void | StartObject ()
void | EndObject (SizeType memberCount)
void | StartArray ()
void | EndArray (SizeType elementCount)
Public Member Functions inherited from GenericValue< Encoding, Allocator >
template<typename Handler >
const GenericValue & | Accept (Handler &handler) const
| Generate events of this value to a Handler. More...
GenericValue & | operator= (GenericValue &rhs)
| Assignment with move semantics. More...
template<typename T >
GenericValue & | operator= (T value)
| Assignment with primitive types. More...
Type | GetType () const
bool | IsNull () const
bool | IsFalse () const
bool | IsTrue () const
bool | IsBool () const
bool | IsObject () const
bool | IsArray () const
bool | IsNumber () const
bool | IsInt () const
bool | IsUint () const
bool | IsInt64 () const
bool | IsUint64 () const
bool | IsDouble () const
bool | IsString () const
GenericValue & | SetNull ()
bool | GetBool () const
GenericValue & | SetBool (bool b)
GenericValue & | SetObject ()
| Set this value as an empty object. More...
GenericValue & | operator[] (const Ch *name)
| Get the value associated with the name. More...
const GenericValue & | operator[] (const Ch *name) const
ConstMemberIterator | MemberBegin () const
| Member iterators. More...
ConstMemberIterator | MemberEnd () const
MemberIterator | MemberBegin ()
MemberIterator | MemberEnd ()
bool | HasMember (const Ch *name) const
| Check whether a member exists in the object. More...
Member * | FindMember (const Ch *name)
| Find member by name. More...
const Member * | FindMember (const Ch *name) const
GenericValue & | AddMember (GenericValue &name, GenericValue &value, Allocator &allocator)
| Add a member (name-value pair) to the object. More...
GenericValue & | AddMember (const Ch *name, Allocator &nameAllocator, GenericValue &value, Allocator &allocator)
GenericValue & | AddMember (const Ch *name, GenericValue &value, Allocator &allocator)
template<typename T >
GenericValue & | AddMember (const Ch *name, T value, Allocator &allocator)
bool | RemoveMember (const Ch *name)
| Remove a member in object by its name. More...
GenericValue & | SetArray ()
| Set this value as an empty array. More...
SizeType | Size () const
| Get the number of elements in array. More...
SizeType | Capacity () const
| Get the capacity of array. More...
bool | Empty () const
| Check whether the array is empty. More...
void | Clear ()
| Remove all elements in the array. More...
GenericValue & | operator[] (SizeType index)
| Get an element from array by index. More...
const GenericValue & | operator[] (SizeType index) const
ValueIterator | Begin ()
| Element iterator. More...
ValueIterator | End ()
ConstValueIterator | Begin () const
ConstValueIterator | End () const
GenericValue & | Reserve (SizeType newCapacity, Allocator &allocator)
| Request the array to have enough capacity to store elements. More...
GenericValue & | PushBack (GenericValue &value, Allocator &allocator)
| Append a value at the end of the array. More...
template<typename T >
GenericValue & | PushBack (T value, Allocator &allocator)
GenericValue & | PopBack ()
| Remove the last element in the array. More...
int | GetInt () const
unsigned | GetUint () const
int64_t | GetInt64 () const
uint64_t | GetUint64 () const
double | GetDouble () const
GenericValue & | SetInt (int i)
GenericValue & | SetUint (unsigned u)
GenericValue & | SetInt64 (int64_t i64)
GenericValue & | SetUint64 (uint64_t u64)
GenericValue & | SetDouble (double d)
const Ch * | GetString () const
SizeType | GetStringLength () const
| Get the length of string. More...
GenericValue & | SetString (const Ch *s, SizeType length)
| Set this value as a string without copying source string. More...
GenericValue & | SetString (const Ch *s)
| Set this value as a string without copying source string. More...
GenericValue & | SetString (const Ch *s, SizeType length, Allocator &allocator)
| Set this value as a string by copying from source string. More...
GenericValue & | SetString (const Ch *s, Allocator &allocator)
| Set this value as a string by copying from source string. More...
| GenericValue ()
| Default constructor creates a null value. More...
| GenericValue (Type type)
| Constructor with JSON value type. More...
| GenericValue (bool b)
| Constructor for boolean value. More...
| GenericValue (int i)
| Constructor for int value. More...
| GenericValue (unsigned u)
| Constructor for unsigned value. More...
| GenericValue (int64_t i64)
| Constructor for int64_t value. More...
| GenericValue (uint64_t u64)
| Constructor for uint64_t value. More...
| GenericValue (double d)
| Constructor for double value. More...
| GenericValue (const Ch *s, SizeType length)
| Constructor for constant string (i.e. do not make a copy of string) More...
| GenericValue (const Ch *s)
| Constructor for constant string (i.e. do not make a copy of string) More...
| GenericValue (const Ch *s, SizeType length, Allocator &allocator)
| Constructor for copy-string (i.e. do make a copy of string) More...
| GenericValue (const Ch *s, Allocator &allocator)
| Constructor for copy-string (i.e. do make a copy of string) More...
| ~GenericValue ()
| Destructor. More...

## Detailed Description

### template<typename Encoding, typename Allocator = MemoryPoolAllocator<>>
class rapidjson::GenericDocument< Encoding, Allocator >

A document for parsing JSON text as DOM.

Template Parameters

  Encoding | encoding for both parsing and string storage.
  Alloactor | allocator for allocating memory for the DOM, and the stack during parsing.

## Member Typedef Documentation

typedef Allocator AllocatorType

Allocator type from template parameter.

typedef Encoding::Ch Ch

Character type derived from Encoding.

typedef GenericValue<Encoding, Allocator> ValueType

Value type of the document.

## Constructor & Destructor Documentation

GenericDocument | ( | Allocator * | allocator = `0`,
|  | size_t | stackCapacity = `kDefaultStackCapacity`
| ) |  |
| inline

Constructor.

Parameters

  allocator | Optional allocator for allocating stack memory.
  stackCapacity | Initial capacity of stack in bytes.

## Member Function Documentation

void Bool | ( | bool | b | ) |
| inline

void Double | ( | double | d | ) |
| inline

void EndArray | ( | SizeType | elementCount | ) |
| inline

void EndObject | ( | SizeType | memberCount | ) |
| inline

Allocator& GetAllocator | ( |  | ) |
| inline

Get the allocator of this document.

size_t GetErrorOffset | ( |  | ) | const
| inline

Get the offset in character of the parsing error.

const char* GetParseError | ( |  | ) | const
| inline

Get the message of parsing error.

size_t GetStackCapacity | ( |  | ) | const
| inline

Get the capacity of stack in bytes.

bool HasParseError | ( |  | ) | const
| inline

Whether a parse error was occured in the last parsing.

void Int | ( | int | i | ) |
| inline

void Int64 | ( | int64_t | i | ) |
| inline

void Null | ( |  | ) |
| inline

GenericDocument& Parse | ( | const Ch * | str | ) |
| inline

Parse JSON text from a read-only string.

Template Parameters

  parseFlags | Combination of ParseFlag (must not contain kParseInsituFlag).

Parameters

  str | Read-only zero-terminated string to be parsed.

GenericDocument& Parse | ( | const Ch * | str | ) |
| inline

GenericDocument& ParseInsitu | ( | Ch * | str | ) |
| inline

Parse JSON text from a mutable string.

Template Parameters

  parseFlags | Combination of ParseFlag.

Parameters

  str | Mutable zero-terminated string to be parsed.

Returns
  The document itself for fluent API.

GenericDocument& ParseInsitu | ( | Ch * | str | ) |
| inline

GenericDocument& ParseStream | ( | InputStream & | is | ) |
| inline

Parse JSON text from an input stream.

Template Parameters

  parseFlags | Combination of ParseFlag.

Parameters

  stream | Input stream to be parsed.

Returns
  The document itself for fluent API.

void StartArray | ( |  | ) |
| inline

void StartObject | ( |  | ) |
| inline

void String | ( | const Ch * | str,
|  | SizeType | length,
|  | bool | copy
| ) |  |
| inline

void Uint | ( | unsigned | i | ) |
| inline

void Uint64 | ( | uint64_t | i | ) |
| inline

The documentation for this class was generated from the following file:

- persistence/rapidjson/include/rapidjson/document.h